﻿using System;
using System.Linq;
using NHibernate;
using NHibernate.Linq;


namespace FluentNHibernateManyToMany
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ISession db = MSSQLSessionFactory.OpenSession())
            {

                var query = (from s in db.Query<Student>()
                             select s 
                             ).OrderBy(x => x.Name).ToList();

                Console.WriteLine("List of classes each student has");
                foreach (Student studentitem in query)
                {
                    foreach (var classitem in studentitem.Class)
                    {
                        Console.WriteLine(studentitem.Name.Trim() + " " + classitem.Name.Trim());
                    }
                }

                Console.WriteLine();

                var query2 = (from c in db.Query<Class>()
                              select c).OrderBy(x => x.Name).ToList();

                Console.WriteLine("List of students in each class");
                foreach (Class classitem in query2)
                {
                    foreach (var studentitem in classitem.Student)
                    {
                        Console.WriteLine(classitem.Name.Trim() + " " + studentitem.Name.Trim());
                    }
                }

                // insert new student
                Student student = new Student()
                {
                    Name = "New Student"
                };

                db.Save(student);

                // insert a new class to the student
                Class tempclass = new Class()
                {
                    Name = "CSC 300",
                    TeacherId = 1
                };

                db.Save(tempclass);

                student.Class.Add(tempclass);
                db.Save(student);

                db.Flush();
            }

            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                var query3 = (from c in db.Query<Class>() select c).OrderBy(x => x.Name).ToList();

                Console.WriteLine();
                foreach (var t in query3)
                {
                    foreach (var tempstudent in t.Student)
                    {
                        Console.WriteLine(t.Name.Trim() + " " + tempstudent.Name.Trim());
                    }
                }
            }

            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                /*
                var student = (from s in db.Query<Student>() 
                               where s.Name == "New Student" 
                               select s).FirstOrDefault();
                
                // Test delete student and connector, but not class
                using (db.BeginTransaction())
                {
                    db.Delete(student);
                    db.Transaction.Commit();
                }
                */
            }

            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                var tempclass = (from c in db.Query<Class>() 
                                 where c.Name == "CSC 300" 
                                 select c).FirstOrDefault();

                // Test delete class and connector, but not student
                using (db.BeginTransaction())
                {
                    db.Delete(tempclass);
                    db.Transaction.Commit();
                }
            }

            Console.ReadKey();
        }
    }
}
