﻿using FluentNHibernate.Mapping;
using System.Collections.Generic;

namespace FluentNHibernateManyToMany
{
    public class Class
    {
        public virtual int Id { get; set; }
        public virtual string Name { get; set; }
        public virtual int TeacherId { get; set; }
        public virtual IList<Student> Student { get; set; }

        public Class()
        {
            Student = new List<Student>();
        }
    }

    public class ClassMap : ClassMap<Class>
    {
        public ClassMap()
        {
            Id(u => u.Id).GeneratedBy.Identity();
            Map(u => u.Name).Nullable();
            HasManyToMany(u => u.Student)
                .Table("studentdata..studentclass")
                .ParentKeyColumn("ClassId")
                .ChildKeyColumn("StudentId")
                .LazyLoad();

            Map(u => u.TeacherId).Not.Nullable();

            Table("facultydata..Class");
        }
    }
}
